/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <stdio.h>
#include <errno.h>
#include "Aff.H"
#include "Con_Wholist.H"
#include "G_Path.H"
#include "C_Pipe.H"
#include "consts.H"
#include "edit.H"
#include "C_Menu.H"
#include "G_Prend.H"
#include "Dat.H"
#include "ROOM.H"
#include "C_Liste.H"
#include "uread.H"
#include "C_Prend.H"
#include "EditFile.H"
#include "G_User.H"
#include "ROOM_ENUM.H"

G_Path G(30*60); // 30 minutes maxi
Aff A;
Con_Wholist W;
C_Pipe P;
Dat * D;
extern LISTE USERS;

G_User * Moi;

int PrendUsers(int numero)
{
  return PrendU(numero,0, 0, 0 );
}

unsigned short NumDeRoom = 3;

int Lit_Sauve(TypeLecture LeType)
{
  char * tp;
  tp = G.GetRoomFile("Infos",NumDeRoom);
  try
    {
      FileInfo FF (tp, LeType,D);
      FF.Proceed();
    }
  catch ( FileProbs )
    {
      fprintf(stderr, "ERREUR: IO %s\n",tp);
      return 1;
    }
  return 0;
}

// Fin des merdes ke je devrais mettre ot part

int Menu_1(char ch)
{
  switch ( ch )
    {
    case '1':
      Prend(D->Cle(C_Nom), 0, C_Nom,D, 0);
      break;
    case '2': 
      if ( Moi->IsRooms() ) 
	return -2;
      else 	
	A.printnumln(M_REVE);
      break;
    case '3': return -3;
    case '4':
      A.printnum(M_nbposts);
      D->SetNum(N_MaxP_N, Prend());
      break;
    case '5': return -4;
    case '6': return -5;
    case '7': 
      {
        A.printnum(M_change_RI);
	unsigned long poil = Prend();
        A.ln();
	EditFile(G.GetRoomInfo(NumDeRoom,1<<poil),M_Nvx_RI,500,O_WRONLY | O_TRUNC); 
      } 
      break;
    case '8': return -6;
    case '9': 
       if ( Moi->IsAdmin() ) 
	return -8;
      else 	
	A.printnumln(M_REVE);
      break;
    case 'H': A.printf2("HelpRA"); break;
    case 'N': EditFile(G.GetRoomFile("Notes",NumDeRoom),M_Nvx_Note,300,O_WRONLY | O_TRUNC); break;
    default: return 1;
    }

  return 0;
}


int Menu_2(char ch)
{
  switch ( ch )
    {
    case 'a': case 'r': case 'l': case 'c':
      Gere(D->L(L_RA),ch,M_DebutQuick);
      break;
    default:
      return 1;
    }
  return 0;
}

int Menu_3(char ch)
{
  int temp = ch -'0';
  if ( temp >=0 && temp <10 )
    {
      D->Swap(N_flags_N,1<<temp);
      return 0;
    }
  return 1; 
}

int Menu_4(char ch )
{
  if (ch>='1' && ch <='1'+G.Nblg())
    {
      D->SetNum(N_D_lang_N, 1 << (ch - '1'));
      return 0;
    } else return 1;
}

int Menu_5(char ch)
{
  if (ch>='1' && ch <='1'+G.Nblg())
    {
      D->Swap(N_langues_N, 1 << (ch -'1')); 
      return 0;
    } else return 1;
}

void Change(unsigned short valeur)
{
  if ( PrendUsers( M_Xenvoyer) ) 
  {
     for (int i=0; i< USERS.size(); i++ )
       D->L(L_Pos)->DATA[USERS.DATA[i]]=valeur;      
  } else printf("Rien de change :)\n");
}

void AffUsers(char * c, LISTE * a, int val)
{
  A.Direct(c);  A.ln();
  int j = 0;
  for (int i=0; i<a->size(); i++)
  {    
    if ( a->DATA[i] == val )
      {
	if (! ( (++j)%4 ) ) A.ln();
	printf("%20s ",W.name(i)); fflush(stdout);
      }
 }
}

int Menu_6(char ch)
{
  switch ( ch )
    {
    case '1': 
      printf("kick des utilisateurs\n");
      Change(65534);
      break;
    case '2':
       printf("reset des utilisateures\n");
       Change(0);
      break;
    case '3':
       printf("mettre au bout des utilisateurs\n");
       Change(65500); // hum, c'est tres laid ca ...
      break;
    case '4':
      printf("faire zapper des utilisateurs\n");
      Change(65535);
      break;
    case '5':
      return -7;
      break;
    case '6':
    {
      LISTE * t = D->L(L_Pos);
      printf("Reseter room\n");
      for ( int i=0; i<t->size(); i++) t->DATA[i]=0; 
      break;
    }
    case '7':
      {
	AffUsers("Liste des utilisateurs ayant zappe la roume:",D->L(L_Pos),65535);
	break;
      }
    case '8':
	AffUsers("Liste des utilisateurs etant kickes de la roume:",D->L(L_Pos),65534);
      break;
    case 'H':
      A.printf2("HelpRAUser");
      break;
    default:
      return 1;
    }
  return 0;
}
 
int Menu_7(char ch)
{
  switch ( ch )
  {
  case 'a': case 'r': case 'l': case 'c':
    Gere(D->L(L_I),ch,M_DebutQuick); 
    break;
  default:
    return 1;
  }
  return 0;
}

int Menu_8(char ch)
{
  if ( ch >='0' && ch <=';')
    {
      unsigned short old_right = D->Num(N_Droits_N);
      unsigned short new_right= old_right;
      A.Change_Droit(0xFFFF,new_right,ch); 
      //      sprintf(L.buf(),"Changed rights from %d to %d !!!!",old_right,new_right);
      D->SetNum(N_Droits_N,new_right);
      //L.Add();
      return 0;
    }
  return 1;
}

void PRINT(char ou,const char * temp)
{
  unsigned short l;
  
  switch ( ou )
    {
    case 1:
      A.printf2(temp,D->St(C_Nom).data(), D->Num(N_MaxP_N));
      break;
    case 3:
      {
	unsigned long t = D->Num(N_flags_N);
	A.printf2(temp,A.bille(t&R_subject),A.bille(t&R_anonym),
		  A.bille(t&R_invite),A.bille(t&R_invisi),A.bille(0), 
		  A.bille(0), A.bille(t&R_male), A.bille(t&R_female), 
		  A.bille(t&R_scram), A.bille(t&R_inv));

      }
      break;   
    case 4: l = D->Num(N_D_lang_N); A.printf2("lang", LGET(l)); break;
    case 5: l = D->Num(N_langues_N); A.printf2("lang", LGET(l)); break;
    case 8: A.Droits_Croix(0xFFFF,D->Num(N_Droits_N)); break;
    case 2: case 7: A.printf2("liste"); break;
    default: A.printf2(temp); 
    }
}


int (* foncs[9])(char ) = { 0, Menu_1, Menu_2, Menu_3, Menu_4,Menu_5, Menu_6 , Menu_7, Menu_8 };
C_Menu M(340,foncs,8,PRINT,"EditRoom");

int main(int argc, char ** argv)
{

  if ( argc != 3 )
  {
    fprintf(stderr,"USAGE: %s ki numderoom\n",argv[0]);
    return 1;
  }

  Moi=new G_User(argv[1]);
  NumDeRoom = atoi(argv[2]);

  
  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));
  
  D = new Dat(U_Cle,tailles,MAX_CH, MAX_L);
  D->L(L_Pos)->doublons=1; // Yes, on doublonne tout ca :)

  if ( Lit_Sauve(k_Read) ) return 1;

  M.push(1);

  while (M.encours())
    {
      M.printline();
      M.GereKey();
    } 


  if ( A.Confirm(M_Sauv_Mod,U_Conf_Sav) )
  {
      Lit_Sauve(k_Write);
      P.Envoie((unsigned char)'R');
      P.Envoie(NumDeRoom);
      P.Envoie((unsigned char)'Z');
      P.flush();
  }

  delete D;
  delete Moi;

  return 0;
}

void terminate(void)
{
  printf("Ze termine\n");
  exit(1);
}

