/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <stdio.h>
#include <errno.h>
#include "Aff.H"
#include "G_wholist.H"
#include "G_Path.H"
#include "C_Pipe.H"
#include "consts.H"
#include "edit.H"
#include "C_Menu.H"
#include "G_Prend.H"
#include "G_User.H"

G_Path G(30*60); // 5 minutes maxi
Aff A;
G_wholist W;
C_Pipe P;

G_User * Moi;

unsigned short numdeliste = 0;

int Menu_1(char ch)
{
  LISTEINFO * l = &(W.mem->Listes[numdeliste]);
  switch ( ch )
    {
    case 'j':
        {
      printf("Num de taverne ?\n");
      numdeliste = Prend();
      if ( numdeliste >= MAX_LISTE ) numdeliste = MAX_LISTE -1 ;
      } 
      break;
    case 'a': case 'r':
      P.EnvoieMsg('l');
      P.Envoie(numdeliste);
      P.Envoie((unsigned char)ch);
      P.flush();
      break;
    case 'n':
      {
	printf("Changer le nom de la taverne en:\n");
	char * tmp = 0;
	if ( Prend(tmp,"Groumph ?",tmp,LG_NOM_LISTE,0) )
	  {
	    strcpy(W.mem->ListName[numdeliste],tmp?tmp:"");
	    if ( tmp ) delete [] tmp;
	  }
	break;
      }
    case 'k':
      {
	printf("Voir ki est dans la taverne\n");
	
	for ( int i=0; i<l->NB_Abones;i++) printf("%s(%d)",W.name(l->Abone[i]),
						  l->Abone[i]);
	printf("\n");
      }
      break;
    default: return 1;
    }

  return 0;
}

void PRINT(char ou, const char * temp)
{
  switch ( ou )
    {
    case 1:
      A.printf2(temp,W.mem->ListName[numdeliste],numdeliste);
      break;
    case 3:
    default: printf("Pas encore d'aff ...\n"); break;
    }
}


int (* foncs[2])(char ) = { 0, Menu_1 };
C_Menu M(350,foncs,2,PRINT,"GereListe");

int main(int argc, char ** argv)
{

  if ( argc != 2 )
  {
    fprintf(stderr,"USAGE: %s ki\n",argv[0]);
    return 1;
  }

  Moi=new G_User(argv[1]);
  
  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));
  P.numdeuser = Moi->numdeuser;

  M.push(1);

  while (M.encours())
    {
      M.printline();
      M.GereKey();
    } 

  delete Moi;
  return 0;
}

void terminate(void)
{
  printf("Ze termine\n");
  exit(1);
}

