/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */
   
#include "G_Path.H"
#include "G_User.H"
#include "Con_Wholist.H"
#include "Aff.H"
#include "LISTE.H"
#include "MAX.H"
#include "AddLog.H"
#include "C_Menu.H"
#include "G_Prend.H"
#include "C_Prend.H"
#include "C_Liste.H"
#include "Debug.H"
#include "EffacerCompte.H"
#include "C_Pipe.H"
#include <regex.h>

G_Path G(35*60); // Tient 30 minutes
Aff A;
Con_Wholist W;
AddLog L("GereUsers");
C_Pipe P;

G_User * Moi;

const int nb_listes    = 10;
const int taille_liste = MAX_USERS;


LISTE * R[nb_listes];

//#define MAX_USERS 30

G_User * U[MAX_USERS];
int PrendUsers(int numero)
{
  int i = PrendU(numero,Moi->D->L(L_friends), Moi->D->Num(N_flags),
                 Moi->numdeuser );
  if ( ! i )
  {
    A.printnumln(M_NoXTo);
    throw Cancel();
  }
  return i;
}

void Delete_Data(void)
{
  for (int i=0;i<MAX_USERS;i++)
    {
      if ( U[i] ) delete U[i];
    }
}

int nb_accounts = 0;
int last_good = 0;

void Load_Data(void)
{
  A.printf2("GereUsersStart");
  forget_debug = 5;
  for (int i=0;i<MAX_USERS;i++)
    {
      G_User ** a = U+i;
      * a = 0;
      try
	{
	  if (W.exist(i))
	    {
	      * a = new G_User(W.name(i));  
	      nb_accounts++;
	      A.Direct('+');
	      last_good = i;
	    }
	  else A.Direct('-');
	}
      catch ( BadUser )
	{
	  A.Direct('!');
	}  
      fflush(stdout);
    }
  forget_debug = 0;
  A.printf2("GereUsersEnd",nb_accounts,last_good,MAX_USERS);
  A.GetCh();
}

void Liste_Mail(void)
{
  printf("Creation liste mail\n");
  FILE * f = fopen("poil","w");
  int i;
  for (i=0; i<MAX_USERS; i++)
    if ( U[i] )
      fprintf(f,"%s\n", U[i]->D->St(C_mail).data());
  fclose(f);
}

static const char * DEBUT_LISTE_HTML = 
"\
<!DOCTYPE HTML PUBLIC \"-//AdvaSoft//DTD HTML 3.2 extended 961018//EN\">\
<HTML>\
  <HEAD>\
    <TITLE>BBS USERS LIST ( Atlantis BBS )</TITLE>\
    <META NAME=\"Author\" CONTENT=\"Gr&eacute;gory VANDENBROUCK\">\
    <META NAME=\"Description\" CONTENT=\"Automatically generated list of the BBS users\">\
    <META NAME=\"GENERATOR\" CONTENT=\"GereUsers application ( option --html-list\">\
  </HEAD>\
\
  <BODY BGCOLOR=\"#D0D0D0\" text=\"#000000\"  link=\"#0000ee\" vlink=\"551a8b\" alink=\"ff0000\">\
\
  There are currently %a accounts<br>\
  Here is the listeux:\
  <UL>\
";
 

static const char * FIN_LISTE_HTML   =
"\
  </UL>\
</BODY>\
</HTML>\
";

static const char * LIGNE_LISTE_HTML = 
"<LI> <A HREF=\"cgi-bin/Profile?login=%s&lang=fr\">%s</A>";


void Liste_html(void)
{
  FILE * f = fopen("poil","w");
  printf("Creation liste html\n");

  fprintf(f,DEBUT_LISTE_HTML,nb_accounts);
  int i;
  for (i=0; i<MAX_USERS; i++)
    if ( U[i] )
      fprintf(f,LIGNE_LISTE_HTML, W.name(i), W.name(i), U[i]->D->St(C_mail).data());
  
  fprintf(f,FIN_LISTE_HTML);
  fclose(f);
}

void Aff_Listes(void)
{
  for (int i=0; i< nb_listes; i++)
    A.printnumln(M_GUsers_afl,i,R[i]->size());
}

int Prend_Liste(int i=0)
{
  int a;
  do 
    { 
      A.printnum(i?M_GUsers_src:M_GUsers_dst,nb_listes-1);
      a = Prend();
      A.ln();
    }
  while ( a < 0 || a >= nb_listes );
  return a;
}

void Recherche_REGEXP_Sur_Champ()
{
  A.printnumln(M_GUsers_reg);
  char c ;

  do 
    {
      A.ln(); A.printnumln(M_Change_Chp);
      for ( unsigned int i=0; i< Moi->D->NC(); i++)	
	printf("(%c = %s) ",char(i+'0'),Moi->D->Cle(i));
      fflush(stdout);
      A.ln();
      c = A.GetCh();
      if ( c == 'q' ) return;
      
    }
  while ( c<'0'  || c>='0'+Moi->D->NC() );

  int champ=  c - '0';

  char p[200];
  regex_t b;
  int error;

  do
    {     
      int i=0;
      A.printnum(M_GUsers_ere);
      while ( ( p[i++]=A.GetCh() ) != '\n' ) { A.Direct(p[i-1]); }
      p[--i]=0;
	  
      A.ln();

      error = regcomp(&b,p,REG_EXTENDED|REG_NOSUB|REG_ICASE);

      if ( ! error ) break;
      
      printf("res1=%d\n",error);
      printf("GAME OVER, TRY AGAIN\n");
    }
  while ( 1 );

  int dest = Prend_Liste();
  A.ln();
  printf("Recherche des champs `%s' matchant `%s' et mise du result dans la liste %d\n",Moi->D->Cle(champ),p,dest);

  for (int i=0; i<MAX_USERS; i++)
    if ( U[i] && ( ! regexec(&b,U[i]->D->St(champ).data(),0,0,0) ) )
      {
	printf("%s(%d),%s\n",W.name(i),i,U[i]->D->St(champ).data());
	R[dest]->Ajoute(i);
      }
  regfree(&b);
  A.Pause();

}




void Recherche_Sur_Grade()
{
  unsigned long grades = 0;
  while ( 1 )
    {    
      A.printf2("GereUsers09",
		A.bille(grades&D_untwit),A.bille(grades&D_help),
		A.bille(grades&D_verif),A.bille(grades&D_rooms),
		A.bille(grades&D_users),
		A.bille(grades&D_kick),A.bille(grades&D_admin));
      int i = Prend();
      if ( i == 99 ) break;
      grades ^= 1 << i;
    }

  A.ln();
  int dest = Prend_Liste();
  A.ln();
  
  for (int i=0; i<MAX_USERS; i++)
    if ( U[i] && ( (U[i]->D->Num(N_flags) & grades) == grades ) )
      {
	A.Direct(W.name(i));
        A.Droits(U[i]->D->Num(N_flags),1);
	R[dest]->Ajoute(i);
      }

  A.Pause();
}

void Recherche_Sur_Nombre(char ch)
{

  char c ;

  do 
    {
      A.ln(); A.printnumln(M_Change_Chp);
      for ( unsigned int i=0; i< Moi->D->NN(); i++)	
	printf("(%c = %s) ",char(i+'0'),Moi->D->Cle(i+Moi->D->NC()+Moi->D->NL()));
      fflush(stdout);
      A.ln();
      c = A.GetCh();
      if ( c == 'q' ) return;
      
    }
  while ( c<'0'  || c>='0'+Moi->D->NN() ); 

  c -= '0';

  A.ln();
  int dest = Prend_Liste();
  A.ln();

  A.printnum(M_GUsers_Nb);

  int comp = Prend();  
  A.ln();

  const char * intitule = Moi->D->Cle(c+Moi->D->NC()+Moi->D->NL());
  
  A.printnumln(M_GUsers_cal,intitule,ch,comp,dest);

  for (int i=0; i<MAX_USERS; i++)
    if ( U[i] )
      {
	unsigned long nb = U[i]->D->Num(c);
	int res = 0;

	switch ( ch )
	  {
	  case '!': if ( nb != comp ) res=1; break;
	  case '<': if ( nb <  comp ) res=1; break;
	  case '>': if ( nb >  comp ) res=1; break;
	  case '=': if ( nb == comp ) res=1; break;
	  default: Debug(4,"erreur case pas cool\n");
	  }
	if ( res )
	  {
	    printf("%s(%d), %s = %d\n",W.name(i),i,intitule,nb);
	    R[dest]->Ajoute(i);
	  } 
      }
  A.Pause();
}

extern LISTE USERS;

void Cree_Liste_Manuellement()
{
  int dest = Prend_Liste();
  PrendU(M_KIEDIT,0, 0, 0);
  R[dest]->Ajoute(USERS);
}

void Liste_Tous_Users()
{
  A.ln();
  int dest = Prend_Liste();
  A.ln();
  
  for (int i=0; i<MAX_USERS; i++)
    if ( U[i] )
      R[dest]->Ajoute(i);  
}

void Liste_Pas_Valides()
{
  A.ln();
  int dest = Prend_Liste();
  A.ln();
  
  for (int i=0; i<MAX_USERS; i++)
    if ( (U[i]) && (! U[i]->D->Set(N_cflag,U_Verified) ) )
      R[dest]->Ajoute(i);
  
  A.Pause();
}

void Afficher_Tous_Admins()
{
  A.ln();
  int aff = 0;
  for (int i=0; i<MAX_USERS; i++)
    if ( (U[i]) )
      {
	LISTE * a = W.RoomsRA(i);

	if ( (U[i]->D->Num(N_flags) != D_untwit) || (a->size()) )
	  {
	    A.printnum(M_ToutToutLu,W.name(i));
	    A.Droits(U[i]->D->Num(N_flags),1);
	    if (W.connected(i)) 
	      {
		A.printnum(M_ProfIci,U[i]->D->St(C_last).data());
		A.printdepuis(U[i]->D->Num(N_lastlog));
		A.ln();
	      } 
	    else 
	      {	
		if (U[i]->D->Num(N_logout))
		  {
		    A.printheure(M_ProfBarre,U[i]->D->Num(N_logout));
		    A.printdepuis(U[i]->D->Num(N_logout));
		    A.ln();
		  } else A.printnumln(M_ProfVrac);
	      }
	    if ( a->size() )
	      {
		A.printnum(M_Prof_10);
		char groumph[5];
		for ( int ii=0; ii< a->size(); ii++ ) 
		  {
		    sprintf(groumph," %d",a->DATA[ii]);
		    A.Direct(groumph);
		  }
		A.ln();
	      }
	  }

      
	delete a;
      }

}

int Menu_1(char ch)
{
  if ( ch >='1' && ch <= '3' ) 
    return - ( ch-'1'+2 );
   
  if ( ch =='l' )
    {
      Afficher_Tous_Admins();
      return 0;
    }
      
  return 1;
}

int Menu_2(char ch)
{
  switch ( ch)
  {
  case '1': Recherche_REGEXP_Sur_Champ(); break;
  case '2': Recherche_Sur_Grade(); break;
  case '3': return -5; break;
  case '4': Cree_Liste_Manuellement(); break;
  case '5': Liste_Tous_Users(); break;
  case '6': Liste_Pas_Valides(); break;
  case 'a': Affiche(*R[Prend_Liste()],0); break;
  case 'f': R[Prend_Liste()]->MetNull(); break;  
  case 'h': A.printf2("GereUsersREGEXP"); break;
  default: return 1;
  }
  return 0;
}



int Menu_3(char ch)
{
  int a, b,c;
  switch ( ch)
  {
  case '+': case '-': case '.':
    A.ln();
    A.printnum(M_GUsers_1l); a = Prend_Liste(1);
    A.printnum(M_GUsers_2l); b = Prend_Liste(1);
    c = Prend_Liste();
    A.printnumln(M_GUsers_cal,a,ch,b,c);
    R[c]->MetNull(); R[c]->Ajoute(* R[a]);
    switch ( ch )
      {
      case '.':
	{
	  for ( int i=0; i< R[c]->size() ; i++)
	    if ( ! R[b]->cherche(R[c]->DATA[i]) ) 
	      {
		R[c]->Enleve(R[c]->DATA[i]); i--;
	      }
	}
	break;
      case '+':
	R[c]->Ajoute(* R[b]);
	break;
      case '-':
	R[c]->Enleve(* R[b]);
	break;
      }
    break;
  case 'a': Affiche(*R[Prend_Liste()],0); break;
  case 'f': R[Prend_Liste()]->MetNull(); break;  
  default: return 1;
  }
  return 0;
}

int Menu_4(char ch)
{
  switch ( ch)
  {
  case 'D': EffacerCompte(* R[Prend_Liste()]);break;
  case 'a': Affiche(*R[Prend_Liste()],0); break;
  case 'f': R[Prend_Liste()]->MetNull(); break;    
  default: return 1;
  }
  return 0;
}

int Menu_5(char ch)
{
  switch ( ch)
  {
  case '>': case '<': case '=': case '!':
    Recherche_Sur_Nombre(ch);
    break; 
  default: return 1;
  }
  return 0;
}

int Menu_6(char ch)
{
  switch ( ch)
  {
  default: return 1;
  }
  return 0;
}



void PRINT(char ou,const char * temp)
{
  switch ( ou )
    {     
    default: 
      Aff_Listes();
      A.printf2(temp);
    }
}

int (* foncs[7])(char ) = { 0, Menu_1, Menu_2, Menu_3, Menu_4, Menu_5, Menu_6  };
C_Menu M(350,foncs,7,PRINT,"GereUsers");

void Manage_Users(void)
{
  int i;

  for (i=0; i<nb_listes;i++) R[i]=new LISTE(taille_liste);

  M.push(1);

  while (M.encours())
    {
      M.printline();
      M.GereKey();
    } 
  for (i=0; i<nb_listes;i++) delete R[i];

  L.Add("*** FINISHED ***");
}



int main(int argc, char ** argv)
{
  char  BUF[100];

  if ( argc < 2 )
    {
      fprintf(stderr,"USAGE: %s ki \n",argv[0]);
      return 1;
    }


  Moi=new G_User(argv[1]);
  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));
  sprintf(BUF,"S(%s)",argv[1]);
  L.AddString(BUF);
  P.numdeuser=Moi->numdeuser;

  L.Add("*** Starting Managing USers ***");

  close(2); // close stderr ...

  Load_Data();

  if (! Moi->D->Set(N_flags,D_users|D_admin) )
    {
      L.Add("*** !!! Simple user -> list of admins  ***");
      Afficher_Tous_Admins();
    }
  else
    {

      if ( argc == 3 )
	{
	  if ( ! strcmp(argv[2],"--list-mail") ) Liste_Mail(); 
	  if ( ! strcmp(argv[2],"--html-list") ) Liste_html();       
	} 
      else
	Manage_Users();

    }
  
  Delete_Data();

  delete Moi;
  return 0;
}

void terminate(void)
{
  exit(0);
}
