/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "consts.H"
#include "G_Prend.H"
#include "G_Path.H"
#include "Aff.H"
#include "C_Menu.H"
#include <stdio.h>
#include "G_User.H"
#include "Vote.H"

#include "uread.H"


G_Path G(30*60); // 30 minutes maxi
Aff A;

G_User * Moi;
Dat * D;


void Deal(TypeLecture LeType)
{
  FileInfo FF(G.GetEtcHome("vote"),LeType,D);
  FF.Proceed();
  if ( LeType == k_Read )
    for ( int i=0; i< NB_vote_listes; i++ ) D->L(i)->Fill();;
}

int nb_votes(int num)
{
 int nb_vote =0;
 const LISTE & a = * D->L(num);
 // unsigned short numdeuser = Moi->numdeuser;
 for (int i=0; i< a.size(); i++ ) if (a.DATA[i]) 
      nb_vote++;
 return nb_vote;
}

int nb_rep(int num, int rep)
{
 int poil =0;
 const LISTE & a = * D->L(num);
 //unsigned short numdeuser = Moi->numdeuser;
 for (int i=0; i< a.size(); i++ ) if (a.DATA[i]==rep) 
      poil++;
 return poil;
}

// The keys you can hit while voting
int Vote_Menu(int num, char ch)
{
  const LISTE & l = * D->L(num);
  //  printf("NUM = %d\n",num);
  int max = MAX_Pos[num];
  unsigned short numdeuser = Moi->numdeuser;
  switch ( ch )
    {
    case 'v':
      {
	if ( ! max )
	  {
	    A.printf2("VoteNo");	    
	    A.GetCh();
	    return 0;
	  }
	if ( l.DATA[numdeuser] )
	  {
	    A.printf2("VoteSorry");	    
	    A.GetCh();
	    return 0;
	  }
	A.printf2("VoteEnter");
	unsigned long poil =  Prend();
	if ( poil > max ) 
	  {
            A.printf2("VoteMistake",poil,max);	   
	    A.GetCh();
	    return 0;
	  }
	
	Deal(k_Read);
	D->L(num)->DATA[numdeuser] = poil;
	Deal(k_Write);
      } 
      return 0;
    case 'r': if (Moi->D->Set(N_flags,D_admin))
      {
	int nb = nb_votes(num);
	printf("\n%d persons have voted \n",nb);
	for (int i=1; i<=max;i++)
	  {
	    int nbrep = nb_rep(num,i);
	    printf("Answer %3d obtains %3d votes, which is %2d%%\n",
		   i,nbrep,(nbrep*100)/nb);
	  }
	A.Pause();
	A.GetCh();
	break;
      }
    default:
      return 1;
    }
  return 0;
}



// Simply prints a Vote file , giving: 
// - the users choice
// - the number of persons who have voted
void Print_Vote_End(int num)
{
  const LISTE & a = * D->L(num);
  A.printf2("VoteEnd",a.DATA[Moi->numdeuser],nb_votes(num));
}

//  Prints the text when an admin flag is re-voted
//
void Adm_Re_Flag(const char * a, char * b, int c)
{
  A.printf2("VoteKeepFlag",a,b);
  Print_Vote_End(c);
}

void New_Admin(int nb, char * intitule,char **ch, int c)
{
  A.printf2("VoteNewFlag",intitule);
  for (int i=0; i< nb; i++)
    printf("%d -  %s\n",i+1,ch[i]);
  Print_Vote_End(c);
}

void Vote_Rules(int c)
{
  A.printf2("VoteKeepRules");
  Print_Vote_End(c);
}

int Menu_1(char ch)
{
  if ( ch >='1' && ch <= '7' )
    return -2 - ch + '1';
  
  return 1;
}

int Menu_2(char c)
{
  return Vote_Menu( V_Armateur, c );
}

int Menu_3(char c)
{
  return Vote_Menu( V_Timonier, c );
}

int Menu_4(char c)
{
  return Vote_Menu( V_Rules, c );
}

void PRINT(char ou, const char * temp)
{
  switch ( ou )
    {
    case  1: A.printf2(temp); break;
      /*    case  2: Adm_Re_Flag("Nort","Armateur",V_Nort); break;
	    case  3: Adm_Re_Flag("Flocon","Armateur",V_Flocon); break;
	    case  4: Adm_Re_Flag("Lhebas","Armateur",V_Lhebas); break;
	    case  5: Adm_Re_Flag("Sam","Armateur",V_Sam); break;
	    case  6: Adm_Re_Flag("Samsara","Timonier",V_Samsara); break;
	    case  7: Adm_Re_Flag("Maddingue","Timonier",V_Maddingue); break;*/
    case 2: New_Admin(nb_new_armateur,"Armateur",Armateur,V_Armateur); break;
    case 3: New_Admin(nb_new_timonier,"Timonier",Timonier,V_Timonier); break;
    case 4: Vote_Rules(V_Rules); break;
    
    default: printf("No Cases for this item\n");
    }
}

int (* foncs[5])(char ) = 
{ 0, Menu_1, Menu_2, Menu_3, Menu_4 };
C_Menu M(330,foncs,5,PRINT,"Vote");

int main(int argc, char ** argv)
{

  if ( argc != 2 )
  {
    fprintf(stderr,"USAGE: %s ki\n",argv[0]);
    return 1;
  }

  Moi=new G_User(argv[1]);
  A.Reset(Moi->D->Num(N_langue),Moi->D->Num(N_cflag),Moi->D->Num(N_more));

  unsigned long t = time(0)-Moi->D->Num(N_first);

  if ( 
      Moi->NotValid() ||   // twitted
      ! Moi->D->Set(N_cflag,U_Verified) || // not validated
      ( t < 60*60*24*60) || // not more than 2 months old
      ( Moi->D->Num(N_logins) < 100 ) // not more than 100 logins
      )
    {
      A.printf2("VoteImpossible");
      delete Moi;
      return 1;
    }

  unsigned int * MAX_L_Vote = new unsigned int[NB_vote_listes];

  for ( int i=0; i< NB_vote_listes; i++ ) MAX_L_Vote[i]= MAX_USERS;


  //  a.Fill();
  D = new Dat(vote_cle,vote_tailles,0, MAX_L_Vote);
  for ( int i=0; i< NB_vote_listes; i++ ) D->L(i)->doublons = 1;
  Deal(k_Read);
  M.push(1);
  
  while (M.encours())
  {
    M.printline();
    M.GereKey();
  }
  delete D;
  delete Moi;
  delete [] MAX_L_Vote;

  return 0;
 
}

void terminate(void)
{
  printf("terminate appele ...\n");
  exit(0);
}

