/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do any improvement */

#include <errno.h>
#include <sys/uio.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <strings.h>
#include <time.h>
#include <ctype.h>
#include "Bot.H"
#include "G_B_S_Pipe.H"
#include "Con_Wholist.H"
#include "consts.H"
#include "TAG.H"

extern G_B_S_Pipe P;
extern Con_Wholist W;

Bot::Bot(const char * nom)
  :C_User_C(nom)
{
  close(0); // A Bot doesn't have any keyboard ...
}

Bot::~Bot()
{

}

int Bot::Attends(int secondes)
{    
  ResetSelect();
  AddSelect(f_r);
  fflush(stdout);

  return Select(secondes);    
}

int Bot::Traite_Def(unsigned char c)
{
  switch ( c )
    {
    case ' ': 
      {
	Un_Post a;
	Get_Post(a); 
	printf("Le Bot a recu un post !! ... PAS NORMAL\n");
      }
      break;
    case 'N': 
      {
	Lit_Sauve(k_Read); 
	W.Update(); 
      }
      break;
    case 'a': case 'A':
      {
	Un_Ack a;
	Get_Ack(c =='a',a); 
	// ignore
      }
      break;
    case 'R': 
      {
	Un_Roume a;
	Get_Room(a); 
	printf("Server sends request to change room, not normal\n");
      }
      break;
    case 'S': 
      {
	printf("Serveur answers ok 4 login\n");
	USRINFO * inf = W.User(numdeuser);  
	if ( inf ) 
	  inf->u_wholist += W_Robot;
	else
	  printf("No wholist place ?????\n");
	W.Set(this);
	W.Update();
      }
      break;
    case 'h': case 'b':
      {
	Un_log a;
	Get_Log(c =='h',a); 
      }
      break;	     
    case 'k': 
      {
	RListe a;
	Get_RListe(a); 
	printf("server sends list of roumes\n");
      }
      break;
    case 'T': 
      {
	Un_Tag a;
	Get_Tag(a); 
	if ( a.type == 'R' ) SendTag();
      }
      break;
    default:
      return 0;
    }
  return 1;
}
