/*********************************************************************
 *                                 *  version          date          *
 *  bot.c                          *    0.2.20           09/02/1998  *
 *                                 *                                 *
 *********************************************************************
 * Copyright (C) 1997-1998 Free Software Foundation, Inc.            *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation; either version 2, or   *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         *
 *                                                                   *
 * ***************************************************************** *
 * This Program has been made by Sebastien Aperghis-Tramoni from     *
 * The Madness Brothers. If you find any bug, or if you do any       *
 * improvment, please contact send him a mail.                       *
 *                                                                   *
 *   Mail: Sebastien.Aperghis@es2i.esil.univ-mrs.fr                  *
 *     or  madingue@tango.resus.univ-mrs.fr                          *
 *   Web:  http://www.resus.org/~madingue                            *
 *                                                                   *
 * ***************************************************************** */


/* ***************************************************************** *
 * standart includes                                                 *
 * ***************************************************************** */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>


/* ***************************************************************** *
 * custom includes                                                   *
 * ***************************************************************** */
#include "bot_rep.H"
#include "G_Path.H"


/* ***************************************************************** *
 * global variables                                                  *
 * ***************************************************************** */
G_Path              G                      ;


/* ***************************************************************** *
 * constants                                                         *
 * ***************************************************************** */
const char *		INTERFACE_VERSION		= "0.2.20";
const char *		BOT_NAME				= "La Vigie";


/* ***************************************************************** *
 * main                                                              *
 * ***************************************************************** */
int main(void) {
	bot_rep *	bot       ;
	
	int 		user      = 123;
	char		msg[500]  ;
	char		msg_type  = 'X';
	char *		ans       ;
	char		ans_type  = 0;
	char *		log_str   ;
	
	int 		i         = 0;
	int 		needed	  = 1;
	
	
	printf("Simple bot version %s\nInterface version %s (%s, %s)\n", BOT_VERSION, INTERFACE_VERSION, __DATE__, __TIME__);
	
	bot = new bot_rep();
	
	printf("Initialization completed. (%d)\n", errno);
	printf("\nYou are now talking with %s.\n", BOT_NAME);
	printf("----------------------------------\n");
	
	while(needed) {
		ans      = NULL;
		ans_type = 0;
		log_str  = NULL;
		
		printf("\nSending a message to %s.\n> ", BOT_NAME);
		gets(msg);
		
		if(strstr(msg, "exit") != NULL) {
			printf("exiting via user break.\n");
			needed = 0;
			break;
		}
		
		log_str = bot->bot_reponse(msg, user, msg_type, &ans, &ans_type);
		
		printf("\n*** Message from %s. ***\n", BOT_NAME);
		printf("%s\n", ans);
		
		delete [] ans;
		delete [] log_str;
		
		if(ans_type == 'k') {
			printf("*** You were kicked by %s. ***\n", BOT_NAME);
			needed = 0;
			break;
		}
	}
	
	delete bot;
	
	printf("Good Bye.\n");
	
	if(errno) {
		fprintf(stderr, "\n* * *  errno = %d  * * *\n", errno);
	}
	return errno;
}


#if !defined(__MWERKS__)
/* ***************************************************************** *
 * terminate                                                         *
 * ---------                                                         *
 *   explanation                                                     *
 *     I needed this function because gcc was claiming that 'there   *
 *     is no terminate() function', so I added it, but I don't need  *
 *     it under CodeWarrior, so I encapsulated it with this #ifdef.  *
 *     You will maybe need that too, so check a particular macro of  *
 *     your compiler and add it to the test above.                   *
 *                                                                   *
 * ***************************************************************** */
terminate(void) {
	printf("* * *  terminate(): errno = %d  * * *\n", errno);
	exit(errno);
}
#endif


/* 
A try of implementing text colors in the MacOS test app

#ifdef __MWERKS__
#include <Quickdraw.h>
#endif


		#ifdef __MWERKS__
		for(i=0; i<=strlen(ans); i++) {
			if(ans[i] == '\\') {
				i++;
				
				switch(ans[i]) {
					case 'a': // normal
						ForeColor(blackColor);
						break;
					
					case 'b': // blue
						ForeColor(blueColor);
						break;
					
					case 'c': // cyan
						ForeColor(cyanColor);
						break;
					
					case 'g': // green
						ForeColor(greenColor);
						break;
					
					case 'p': // pink
						ForeColor(magentaColor);
						break;
					
					case 'r': // red
						ForeColor(redColor);
						break;
					
					case 'y': // yellow
						ForeColor(yellowColor);
						break;
				}
				
			} else {
				printf("%c", ans[i]);
			}
		}
		#elif
		printf("%s\n", ans);
		#endif
*/