/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __G_B_R_PIPE__
#define __G_B_R_PIPE__

#include "RECV.H"

// for select
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
 
/*
  General Bufferized Pipe to RECV data ......
  Deals with:
  - infinite size
  - Receiving data by pacquets ..

*/


class RecvPipeProbs
{
};

class PlusPersonne
{
};


class G_B_R_Pipe: public virtual RECV
{
public:
  int f_r;         // file descripter of the pipe 
private:
  int bufsize;      // size of the buffer
  int pos;          // position in buffer for recving
  int pos_lecture;  // position in buffer for reading
  char * buffer;    // buffer
  char * NomDuPipe; // name of the pipe, deleted at the end
  fd_set fdset;
  int maxfd;
public:
  G_B_R_Pipe(char *);
  ~G_B_R_Pipe();
  
  void Lit(unsigned short & a) { RECV::Lit(a); }
  void Lit(unsigned char & a) { RECV::Lit(a); }
  void Lit(char * & a) {RECV::Lit(a); }
  void Lit(String & a) {RECV::Lit(a); }       
  void LitMsg(unsigned char & a, unsigned short & b) { RECV::LitMsg(a,b); }
  void Lit(LISTE &a) { RECV::Lit(a); }

  void Lit(void * , unsigned int );
  void Read(void * , unsigned int );

  void ResetSelect(void);
  void AddSelect(int );
  int Select(int);
  int IsSelect(int);
  int InitRead();
};

#endif
