/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "consts.H"
#include <strings.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>
#include "Aff.H"
#include "G_wholist.H"
#include "G_Path.H"
#include "Profile.H"
#include "LISTE.H"

extern Aff A;
extern G_wholist W;
extern G_Path G;

static int acces;

Profile::Profile(G_User * a)
{
  D=a->D;
  numdeuser = a-> numdeuser; 
  AA = a;
}

Profile::~Profile()
{

}

char * Profile::ChpN(int i, unsigned long j)
{
  return A.HiddenN(D->Num(i), D->Num(N_cflag) & j, acces);
}

char * Profile::ChpC(int i, unsigned long j)
{
  return A.HiddenC(D->St(i),  D->Num(N_cflag) & j, acces);
}

void Profile::View(char type,unsigned short ZeNum, unsigned long ZeFlag)
{  
  int num=-1;
  W.mem->Stat[N_ser_profile]++;
  for (unsigned int i=0; i<G.Nblg();i++) if ((unsigned)(1<<i) == D->Num(N_langue) ) num=i;
 
  acces = ( ( ZeNum == numdeuser  ) || ( ZeFlag & D_users ) );
  unsigned short l = D->Num(N_comprises) ;

  A.ln();
  // Nick 
  A.printnumln(M_Prof_0,A.videC(AA->Nick),
	       ChpN(N_numdeuser,U_C_num),A.videC(D->St(C_extra))
	       );
  // Barreur ?
  if ( D->Num(N_flags) & D_help  ) A.printnumln(M_Prof_8); else A.printnumln(M_Prof_9);
  if ( AA->NotValid() ) A.printnumln(M_Twited);
  // Affichage des droits
  if ( acces ) A.Droits(D->Num(N_flags),1);
  // Affichage du fait que verified ou pas
  if ( ( ( ZeFlag & D_verif ) || ( ZeFlag & D_users ) ) && ! ( D->Set(N_cflag,U_Verified) ) )
    A.printnumln(M_Non_Verif);
  // Nom, mail
  A.printnumln(M_Prof_2,ChpC(C_nom,U_C_name),ChpC(C_mail,U_C_mail));
  // Langues
  // Pour le Barreur, special, il peut voir la langue !! 
  int ancien = acces; acces |= ( ZeFlag & D_help);
  A.printnumln(M_Prof_5,A.HiddenC(G.Lg(num),D->Num(N_cflag) & U_C_pays, acces ));
  acces = ancien;
  // Langues comprises
  if ( M_Langues )
    A.printnumln(M_Langues, A.GetNum(M_lg_Comp2), LGET(l));
  // Big profile ?
  if ( type != 'p' )
    { // Affichage des rooms ou RA
      LISTE * temp = W.RoomsRA(numdeuser);
      if ( temp->size() )
	{
	  A.printnum(M_Prof_10);
	  char groumph[5];
	  for ( int ii=0; ii< temp->size(); ii++ ) 
	    {
	      sprintf(groumph," %d",temp->DATA[ii]);
	      A.Direct(groumph);
	    }
	  A.ln();
	}
      delete temp;
      // Doing
      if ( ! D->St(C_doing).null() ) 
	A.printnumln(M_Prof_3,A.colorize(D->St(C_doing).data()));
      // URL
      A.PrintIfOk(M_Prof_4,D->St(C_url));
      // Adresse
      if ( ( ! D->St(C_adresse).null()) || 
	   ( ! D->St(C_zip).null()) || 
           ( ! D->St(C_ville).null()) || 
	   ( ! D->St(C_pays).null() ) )
	A.printnumln(M_Prof_6,D->St(C_adresse).data(),
		     D->St(C_zip).data(),
		     D->St(C_ville).data(),
		     D->St(C_pays).data() );
      // Tel
      A.PrintIfOk(M_Prof_7,D->St(C_tel) );
      // CV
      A.PrintIfOk(M_Prof_CV,D->St(C_CV) );
      // Numero d'ICQ
      int ICQ = D->Num(N_ICQ);
      if ( ICQ )
	A.printnumln(M_Prof_ICQ,ICQ);
      // Coco infos
      if ( AA->PlayCoco() )
	A.printnumln(M_Prof_Coco,D->Num(N_TagSc)); else A.printnumln(M_Prof_NotCoc);
      // Temps passe
      A.printnumln(M_Prof_1,ChpN(N_logins,U_C_log), 
		   A.HiddenN(D->Num(N_tpspasse)/60/60,
			     D->Num(N_cflag) & U_C_time,
			     acces ),
		   (D->Num(N_tpspasse)*100)/(time(0)-D->Num(N_first)) );
      A.printnumln(M_Stats,D->Num(N_Xe),D->Num(N_Xr),D->Num(N_Post));
    }
  if (W.connected(numdeuser)) 
  {
    A.printnum(M_ProfIci,D->St(C_last).data());
    A.printdepuis(D->Num(N_lastlog));
    A.ln();
  } else 
  {
    A.printnum(M_ProfDepuis,D->St(C_last).data());
    A.printheure(M_HeurePost,D->Num(N_lastlog));
    A.ln();
    if (D->Num(N_logout))
    {
      A.printheure(M_ProfBarre,D->Num(N_logout));
      A.printdepuis(D->Num(N_logout));
      A.ln();
    } else A.printnumln(M_ProfVrac);
  }
 if ( type == 16 || A.Confirm(M_View_MSG,U_Conf_Pro) )
     A.PrintFile(G.GetUserFile(AA->Nick,"profile"),0);
 if ( type == 'p' ) A.printnumln(M_Prof_Short);

  A.ln();
}


