/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "S_Hash.H"
#include "Debug.H"

void S_Hash::insert( const char * nom, unsigned short id )
{
  int i,ind = index(nom[0]);

  // Copy name in good place
  strcpy(Str(id),nom);
 
  // look for where to put the index
  for(; ind<nb(); ind++)
    {
      if ( ! table(ind) ) break; // available place
      if (strcmp( I_Str(ind) , nom ) >= 0 ) break; // Oups, too far away
    }
  //  printf("Je vais inserer, place = %d\n",ind);

  // get a free place
  for( i = nb(); i > ind; i-- ) table(i)=table(i-1);
  
  // update the table
  table(ind)=id;

  // one more entry now
  nb()++;

  // update indices
  for( i = nom[0]+1; i < 254; i++) index(i)++;
}


void S_Hash::remove(unsigned short id)
{   
  Debug(0,"Asked for removal on id = %d\n",id);
  for(int i=0; i < nb() ; i++) 
    if( table(i) == id )
      { 
	Debug(0,"Found id=%d, position=%d, Str='%s'\n",id,i,Str(id));

	int j;
	//on l'a trouve et on tasse la table
        for(j = i; j < nb()-1; j++) table(j)=table(j+1);		  
	// on dit ke une entree en moins
	nb()--;
	//on met a jour la table d'index
	for(j= (Str(id)[0]) + 1; j < 255; j++) index(j)--;      

	Str(id)[0]=0; // Delete string

	break;
      }
}

