/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "C_room.H"
#include "Aff.H"
#include "C_wholist.H"
#include "edit.H"
#include "consts.H"
#include "C_Menu.H"
#include "C_User_C.H"
#include "G_Path.H"
#include "consts.H"
#include "G_Context.H"
#include "G_Prend.H"
#include "Debug.H"

extern Aff A;
extern C_User_C * Moi;
extern C_wholist W;
extern C_Menu M;
extern LISTE USERS;
extern G_Context C;
extern G_Path G;

C_room * ZeRoom = 0;

extern int num_barre;
extern int PrendUsers(int );

void ChangeRoom(const Un_Roume & a)
  // Lit dans le pipe la room en cours, + la pos, + le max
{
  if ( ! ZeRoom || ZeRoom->NumRoom  != a.numroom ) 
  {
    A.ln();
    if ( ZeRoom ) delete ZeRoom;
    ZeRoom = new C_room(a.numroom,a.pos,a.maxpos);
  }
  else 
  {
    ZeRoom -> pos = a.pos; ZeRoom->TotalPost = a.maxpos;
  }
}


C_room::C_room(unsigned short i, unsigned short j, unsigned short k)
  :pos(j),TotalPost(k),NumRoom(i),user(0)
{
  if ( NumRoom != 65535 && NumRoom !=8 ) A.printnumln(M_VaRoom,W.RoomName(NumRoom));
}

C_room::~C_room(void)
{
}

inline int C_room::Twited()
{
  if ( NumRoom == 65535 ) return 1;
  if ( pos == 65534 )  
    {
      A.printnumln(M_Twited_R,W.RoomName(NumRoom),NumRoom);
      return 1;
    }
  return 0;
}

int C_room::CHEF(void)
{
  return (
	  W.IsRA(Moi->numdeuser,NumRoom) || 
	  ( Moi->D->Set(N_flags , D_rooms) && NumRoom >=10 ) ||
	  ( Moi->D->Set(N_flags , D_admin) && NumRoom < 10 ) );
}

int C_room::IsMine(void)
{
  return (CHEF() || user == Moi->numdeuser);
}
 
void C_room::CanPost()
{
  if ( Twited() ) throw Cancel();
  if ( ! NumRoom ) {  A.printnumln(M_UsexX); throw Cancel(); }

  ROOMINFO * poil = W.Room(NumRoom);

  unsigned short F =  poil->flags;

  if ( ( F & R_invite ) && !
       ( CHEF() || W.IsInvited(Moi->numdeuser,NumRoom)) )
  {
    A.printnumln(M_PasPost);
    throw Cancel();
  }

  if ( F & R_1_only ) // just one guy can post in this room in a time
  {
    if ( W.NB_users_posting(NumRoom) )
    {
      A.printnumln(M_Protected);
      throw Cancel();
    }
  }
  if ( ! ( poil->comprises & Moi->D->Num(N_comprises) ) )
    {
      A.printf2("NoComprises");
      throw Cancel();
    }
}

void C_room::Poster(int reply)
{
  CanPost(); // check if Can post
  
  W.Mine-> u_room = NumRoom;
  
  char * alias=0 , * subject=0, * post=0;
  unsigned short F =  W.mem->Rooms[NumRoom].flags;

  if ( NumRoom == 1 )
    PrendUsers(M_Xenvoyer+9);

  if (!(Moi->D->Set(N_cflag, U_expert))) A.printf2("HelpPost");

  Editeur * edit;

  if ( NumRoom != 1 )
    {
      if ( F &  R_anonym )
	{
	  A.printnum(M_RPostAlias); 
	  if ( ! Moi->D->St(C_alias).null() )
	    {
	      alias = strdup(Moi->D->St(C_alias).data());
	      A.Direct(alias);
	    }
	  else
	    {
	      edit = new Editeur(Context_Alias);
	      alias = edit->run();
	      delete edit;  
	    }
	  
	  A.ln();	 
	} 
      
      if ( F & R_subject )
	{
	  edit = new Editeur(Context_Subject);
	  A.printnum(M_RPostSujet); subject= edit->run();
	  A.ln();
	  delete edit;
	} 
    }
  
  edit = new Editeur(* C.Get(8));
  A.printnumln(M_RPostEnter); post = edit->run();
  A.ln();
  delete edit;

  if (post)
  {
    if ( NumRoom == 1 )
      Moi->Mail(USERS,post,reply);
    else
      {
	/*	A.Direct("Right= ? ");
		unsigned short right = Prend();*/
	unsigned short right = 0;

	Moi->Poste(NumRoom, subject,alias,post,reply,right);
      }
  } 
  else A.printnumln(M_RPostAbort);
  if ( subject) delete [] subject;
  if ( alias ) delete [] alias;
  if ( post ) delete [] post;
}

void C_room::Deleter(void)
{
  if ( Twited() ) return;
  if (  IsMine()  )
    {
      if ( ! A.Confirm(M_Eff_Post,U_Conf_Del) ) return;
      Moi->DeletePost(NumRoom, pos);
      GoBack(1);
    } else A.printnumln(M_Cant_del);
}

void C_room::GetNext(void)
{
  if ( Twited() ) return;
  Moi->GetNextPost(NumRoom);
}

void C_room::Oublie()
{
  if ( Twited() ) return;
  SetPos(TotalPost);
}

void C_room::GoBack(unsigned short i)
{ 
  if ( Twited() ) return;

  if ( pos > i )  pos -= i; else pos = 0;
  SetPos(pos);
  GetNext();
}

void C_room::SetPos(unsigned short nvellepos)
{
  if ( Twited() ) return;
  Moi->SetPosRoom(NumRoom,nvellepos);
}

void C_room::PrintPost(const Un_Post & a)
{
  user = a.ki;

  if (Moi->D->L(L_ignore)->cherche(user))
    {
      A.printnumln(M_Ignore_Post,W.name(user));
      return;
    }

  A.ln2();


  switch ( a.TYPE_ROOM )
    {
    case 'L': case 'M':
      if ( NumRoom == 0 ) 
	{
	  A.printnum(M_Log_Msg,a.type,W.name(a.ki));
	}
      else
	{
	  A.printnumln(M_BarrePost);
	  A.printnum(M_PostNorm, W.name(a.ki));
	}
      A.printheure(M_HeurePost,a.date);
      if ( a.nb > 1)
	{
	  A.ln();
	  A.printnum(M_SendTo);
	  for ( int i=1; i<a.nb; i++ )
	    A.printnum(M_Humf,W.name(a.Ki[i]),a.Koa[i]);
	}
      break;
    case 'N':       
       A.printnumln(117);
       if (!a.alias.null())
	 {
	   if ( IsMine() )
	     A.printnum(M_PostAliasS,a.alias.data(), W.name(a.ki)  ); else
	       A.printnum(M_PostAlias , a.alias.data());
	 } else A.printnum(M_PostNorm, W.name(a.ki));
       
       A.printheure(M_HeurePost,a.date);
      
       break;
    default:
      Debug(1,"Oups, can not print this post .");
    }

  if (a.move_u) A.printnum(M_PostMove, W.name(a.move_u), W.RoomName(a.move_r)); 
  A.ln();
  A.printnumln(117);

  if ( a.right )
  {
    A.printnum(M_GRADES);
    A.Droits(a.right,0);
  }
  
  if ( a.reply_r )
    {
      A.printnumln(M_Re_Post,a.reply_s.data(),a.reply_u.data(),a.reply_n,a.reply_r);
    }
  
  if (!a.sujet.null())
    {
      A.printnum(M_RPostSujet); A.Direct(A.colorize(a.sujet.data())); A.Blank();
      A.ln();
    }

  if (!a.post.null()) A.Direct(A.colorize(a.post.data()));
  A.ln();
}

void C_room::PrintLine()
{ 
  //  A.NewMore();
  if ( Twited() ) return;
  A.ln();

  if ( ! (Moi->D->Set(N_cflag, U_Barre ) ) )
      A.printnumln(170+num_barre);

  if ( pos == 65535 ) // Zapped
  {
    A.printnum(M_ZapPost,W.RoomName(NumRoom), NumRoom); 
    return; 
  }

    if ( pos != TotalPost )  A.printnum(M_FinPost,   W.RoomName(NumRoom), NumRoom,pos,TotalPost,TotalPost-pos); 
   else
    A.printnum(M_ToutToutLu,W.RoomName(NumRoom)); 
    
}

void C_room::PrintInfo(char c)
{
  if ( Twited() ) return;

  switch ( c )
  {
    case 'i': W.AffRoom(NumRoom); break;
    case 'I': 
      W.AffRoom(NumRoom); 
      if ( !  A.PrintFile(G.GetRoomInfo(NumRoom,
					Moi->D->Num(N_langue)),0) )
	{
	  A.printf2("NoRoomInfo");	  
	  if ( ! A.PrintFile(G.GetRoomInfo(NumRoom,
					    W.mem->Rooms[NumRoom].comprises),0) )
	    A.printf2("NoRoomInfoAtAll");	
	}      
      break;
    default: Debug(1,"C_room::PrintInfo()\n"); 
  }
}



