/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "C_wholist.H"
#include "Aff.H"
#include "Debug.H"
#include "C_Liste.H"
#include <time.h>
#include <string.h>

extern Aff A;

C_wholist::C_wholist(void)
  :Con_Wholist()
{
}

C_wholist::~C_wholist(void)
{
}

int C_wholist::IsXing(unsigned short src, unsigned short dest)
  // Est ce ke src est en train de Xer dest ?
{
  USRINFO * poil = User(src);
  if ( ! poil ) return 0;
  LISTE a(MaxUSR,poil->ZeUSR,&(poil->nbusr));

  return a.cherche(dest);
}

void C_wholist::Affiche(char type)
{
  tm * HEURE;
  time_t temps;
  temps=time(0); HEURE = localtime(&temps);
  mem->Stat[N_ser_wholist]++;
  unsigned short numdeuser = Moi->numdeuser;
  unsigned short options = Moi->D->Num(N_CWhol);
  int shortWL = (type == 'w') || (type == 23 && (options  & CW_Short ) );

  A.ln2(); 

  if (mem->nbpers>1)
  A.printnumln(M_WholistDb,mem->nbpers,HEURE->tm_hour,HEURE->tm_min); else
  A.printnumln(M_WholistSeul,HEURE->tm_hour,HEURE->tm_min);

  A.ln();
 
  if ( ! shortWL ) A.printnumln(M_WholistDbW);

  A.printnumln(M_WholistBarr);

  int i;

  for (i=0;i<mem->nbpers;i++)
  {
    unsigned short user = mem->ki[i];
    USRINFO * INFO = mem->Infos + mem->place[i];
    unsigned int j=(temps-INFO->last)/60;
    unsigned short ZeFlag = INFO->u_wholist;
    int Affiche = ! ( ZeFlag & W_Hidden );
    
    if (type == 23 & Affiche) // Si il faut afficher et Custom Wholist
    {
      /*int tempres;
      Affiche = options & CW_Depart;
      //      printf(Affiche ? "Select pas defaut\n":"Pas select pas defaut\n");
      //tempres = Moi->UserListe[L_friends]->cherche(LeMec);
      //printf(tempres ? "Yabon pour ce mec\n":"Yapasbon pour ce mec\n");
      if ( options & CW_Frlist ) 
      {
         Affiche |= tempres; 
      } else 
      {
        Affiche &= tempres;
	}*/
       if ( j >= Moi->D->Num(N_idle) ) Affiche = 0;

    }
    if ( Affiche )
    { 
      char f1=' ',f2=' ', f3=' ',f4,f5=' ';
          
      if (j>=2) f5='#';
      if ( ZeFlag & W_Tag    ) f2='C'; 
      if ( ! ( INFO->u_options & U_Verified) ) f2 = 'V'; // Not validated user
      if ( ZeFlag & W_Help   ) f1='%';
      if ( ZeFlag & W_Disabl ) f1='*';
      if ( ZeFlag & W_poste  ) f3='+';
      if ( ZeFlag & W_X )
      { 
        f3 = '?'; 
        if (IsXing(user,numdeuser)) f3='X';
      }
      if ( ZeFlag & W_Vote )
      {
        f3 = 'v';
      }
      //      f4 = ( ZeFlag & W_Chat ) ? '&':' ';
      f4 = ( ZeFlag & W_Robot ) ? 'R': ' ';
      if ( shortWL  )
      {
         A.printnum(M_WholistSHo,f1,f3,f4,f5,name(user));
         if ( ! ((i+1)%4) ) A.ln();
      } else
      {
        int jj = (temps-INFO->login)/60;
	
        A.printnum(user==numdeuser ? M_WholistU: M_Wholist,
        name(user),f2,f1,f3,f4,f5,jj/60,jj % 60, 
	INFO->From);

	if ( j>= 5 ) // rien depuis + de 5 minutes
	    A.printnumln((ZeFlag & ( W_X |W_poste ) )?M_wh_wr:M_wh_IDLE,j);
	else
	  if (strlen(INFO->Doing)) 
	    { 
	      A.Direct(A.colorize(INFO->Doing)); 
	      A.ln();
	    }
	  else
	    A.printnumln(M_wh_new);
        A.Blank();
      }
    }
  } 

  if ( shortWL && (i%4) ) A.ln();

  A.ln(); 
}

void C_wholist::AffRoom(unsigned short num)
{
  ROOMINFO * ici = Room(num);
  if ( ! RoomName(num) ) { Debug(1,"Pas de room ?\n"); return; }
  A.ln();
  unsigned short F = ici->flags;
  A.printf2("RI",RoomName(num), num,
	    A.bille(F & R_subject), A.bille( F & R_anonym),
	    A.bille(F & R_invite),  A.bille(F & R_invisi ),
	    A.bille(F & R_scram),   A.bille(F & R_inv));
#warning "refaire en utilisant Affiche(const LISTE& L,int j)"
  unsigned short groumph;
  if ( (  groumph = ici->NB_Ra ) )
  {
    for ( int i=0; i< groumph; i++ ) A.printnum(M_Cop_Emb,name(ici->RA[i]));
    A.ln();
  } else A.printnumln(M_No_Ra);
  unsigned long l = ici->comprises;
  A.printnumln(M_Langues,A.GetNum(M_Lg_Comp), LGET(l)); 
}

unsigned short C_wholist::Look_for_SG(unsigned short pastouch, unsigned short SG)
{  
  unsigned long f;
  int yabon= 0;
  USRINFO * poal=User(SG);
  if ( poal )
    {
      f = poal->u_wholist;
      yabon = ( f & W_Help) && (! ( f & W_Disabl ) );
    }
  if ( yabon ) return SG;
  for (int i=0;i<NB();i++) 
    {
      unsigned short ki = mem->ki[i];
      poal = mem->Infos+mem->place[i];
      f  = poal ->u_wholist; 
      if ( (f & W_Help) && (! ( f & W_Disabl )) && ( ki != pastouch ) )
	  return ki;
    }
  return 0;
}
 
int C_wholist::NB_users_posting(unsigned short room)
{
  int nb = 0;
  for (int i=0;i<mem->nbpers;i++)
  {
    USRINFO * INFO = mem->Infos + mem->place[i];
    if ( (INFO->u_wholist & W_poste )  && ( INFO->u_room == room ) ) nb ++;
  }
  return nb;
}
