/* ***************************************************************** *
 * Login - General utility functions                                 *
 * ================================================================= *
 * Creation date . . . . . . . . . . . . . . . . . . Tue 01 Sep 1998 *
 * Modification date . . . . . . . . . . . . . . . . Sun 17 Jan 1999 *
 * ================================================================= *
 * Copyright (C) 1997-1998 Free Software Foundation, Inc.            *
 *                                                                   *
 * This program  is  free software;  you can  redistribute it and/or *
 * modify it  under the terms  of the GNU  General Public License as *
 * published by  the Free Software Foundation;  either version 2, or *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program  is distributed in the hope  that it will be useful, *
 * but WITHOUT  ANY WARRANTY;  without even  the implied warranty of *
 * MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the *
 * GNU General Public License for more details.                      *
 *                                                                   *
 * You should have received a copy of the GNU General Public License *
 * along  with  this  program;  if not,  write to  the Free Software *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         *
 *                                                                   *
 * ================================================================= *
 * Authors                                                           *
 *   Sebastien APERGHIS-TRAMONI <saper@esil.univ-mrs.fr>             *
 *                                                                   *
 * If you find any bug, or if you do any improvment, please send us  *
 * a mail (possibly with diff and/or correction).                    *
 *                                                                   *
 * ***************************************************************** */


#ifndef LOGIN_UTILS_H
#define LOGIN_UTILS_H


/* ***************************************************************** *
 * enums                                                             *
 * ***************************************************************** */
// ASCII Control Characters
enum ASCII_Ctrl {
    NUL, SOH, STX, ETX, EOT, ENQ, ACK, BEL, 
    BS , HT , LF , VT , FF , CR , SO , SI , 
    DLE, DC1, DC2, DC3, DC4, NAK, SYN, ETB, 
    CAN, EM , SUB, ESC, FS , GS , RS , US ,
    SPC, DEL = 0x7F
};


/* ***************************************************************** *
 * prototypes                                                        *
 * ***************************************************************** */
int     print_file      (char * filename);
int     lower_case      (char * str);
int     chomp           (char * str);
int     match           (char * pattern, char * string);
char    star            (int needed);
char    cross           (int needed);
char *  empty           (char * str);

#endif /* LOGIN_UTILS_H */
