/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <sys/ipc.h>
#include <unistd.h>
#include <strings.h>
#include <errno.h>
#include "S_pipe.H"
#include "G_Path.H"
#include "Debug.H"

extern G_Path G;

S_pipe::S_pipe(void)
{
  NomDuPipe = G.GetCommFile("pipo");

  if (mkfifo(NomDuPipe,0644) < 0)
    if (errno != EEXIST) 
      { Debug_Error(3,"S_Pipe::S_Pipe(mkfifo())"); throw ; } 

  Debug(3,"Pipe [%s] opened, waiting for first connection\n","pipo");

  if ((d = open(NomDuPipe,O_RDONLY)) < 0) 
    { Debug_Error(3,"S_Pipe::S_Pipe(open())"); throw ; }  
}

S_pipe::~S_pipe(void)
{
  Debug(0,"S_Pipe::~S_Pipe()\n");
  close(d);
  unlink(NomDuPipe);
  delete [] NomDuPipe;
}

void S_pipe::Lit(void * koa,unsigned int taille)
{
  int n = read(d,koa,taille);
  switch ( n )
  {
  case -1: 
    Debug_Error(2,"S_Pipe::Lit()"); 
    throw ErreurLecture() ;
  case 0:
    if ( taille )
      throw PlusPersonne() ;
    else
      koa = 0;
  }
}

