/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#ifndef __POST__
#define __POST__

#include "S_Load.H"
#include "S_Save.H"
#include <sys/types.h> // for time_t
#include "String.H"

/*
  This is the general definition of a post ...
  A post is made by a user, for one or several or all users
*/


class Post
{
public:
  Post();
  virtual ~Post() = 0;
  virtual void Lit(S_Load *a) = 0;
  virtual void Sauve(S_Save *a) = 0;
  virtual void Recoit(unsigned short) =0;
  virtual void Envoie(unsigned short) =0 ;
  virtual Post * CopyPost(void) = 0;
  int  GetNum(unsigned short);
  void SetNum(unsigned short, unsigned short );
  int  CanDel();
  int  IsMine(unsigned short);
  void Del(unsigned short );
  void MarkRead(unsigned short );
  void UpdatePost(Post & );

  virtual const char * username() = 0; // name of the user who posted, or his alias
protected:
  time_t date;  // When was it made
  String post;  // What is in it

  int MULTIPLE; // =1 if more than one user share the positions

  void LIT  (S_Load *a);
  void SAUVE(S_Save *a);
  void RECOIT(unsigned short);
  void ENVOIE(unsigned short );
public:
  String subject;   // subject if exists

  unsigned short NB_KI;     // For how many persons ( if MULTIPLE )
  unsigned short * KI;      // From / For who ?
  unsigned char  * KI_Etat; // State: Not Read, Read, Deleted ...
  unsigned short * POS;     // Positions of users for this post
  unsigned short right;     // admin rights with this post

  unsigned short move_u;    // user who moved the post
  unsigned short move_r;    // room from where the post was moved  

  unsigned short ref_r;     // room this post replies to
  unsigned short ref_n;     // number of post this post replies to
  String         ref_u;     // user who did the parent post or "ANONYMOUS"
  String         ref_s;     // subject, if exists of the first post

  Post * SUIV;              // NEXT Post 

  unsigned char  TYPE_ROOM; // IMPORTANT !! What is the type of this room
};

#endif
