/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include "Post.H"

#include "G_B_R_Pipe.H"
#include "S_Users.H"
#include "Debug.H"

extern G_B_R_Pipe p;
extern S_Users U;

Post::Post()
  :NB_KI(0),KI(0),KI_Etat(0),POS(0),right(0),move_u(0),move_r(0),
   ref_r(0),ref_n(0),SUIV(0)
{
  date = time(0);
}

Post::~Post()
{
  if ( KI )      delete [] KI;
  if ( KI_Etat ) delete [] KI_Etat;
  if ( POS )     delete [] POS; 
}

void Post::UpdatePost(Post & a )
{
  a.post = post;
  
  a.NB_KI = NB_KI;
  if ( NB_KI )
  {
    a.KI = new unsigned short[NB_KI];
    a.KI_Etat = new unsigned char[NB_KI];
    a.POS = new unsigned short[NB_KI];
    for ( int i=0; i< NB_KI; i++ ) 
    {
      a.KI[i] = KI[i]; a.POS[i] = POS[i]; a.KI_Etat[i] = KI_Etat[i];
    }
  }
  a.move_u = move_u;
  a.move_r = move_r;
  a.ref_n  = ref_n;
  a.ref_r  = ref_r;
  a.ref_u  = ref_u;
  a.ref_s  = ref_s;
  a.right  = right;
  
  a.TYPE_ROOM = TYPE_ROOM; 
}

int Post::CanDel()
{
  for ( int i=0; i < NB_KI; i++)
    if ( KI_Etat[i] != 'D' ) return 0;
  return 1; // Tout le monde l'a delete
}

int Post::IsMine(unsigned short ki)
{
  if ( ! MULTIPLE ) return 1;
  for ( int i=0; i< NB_KI; i++)
      if ( KI[i]==ki ) return 1;
  return 0;
}

void Post::Del(unsigned short nom)
{
  if ( ! MULTIPLE ) KI_Etat[0]='D'; else
  for ( int i=0; i< NB_KI; i++)
    if (  KI[i]==nom ) { KI_Etat[i] = 'D'; return ; }
}

int Post::GetNum(unsigned short ki)
{
  if ( ! MULTIPLE ) return POS[0]; else
  for ( int i=0; i<NB_KI; i++)
    if ( KI[i] == ki ) return POS[i];
  return -1;
}

void Post::SetNum(unsigned short ki, unsigned short num)
{
  if ( ! MULTIPLE ) POS[0] = num; else
  for ( int i=0; i<NB_KI; i++)
    if ( KI[i] == ki ) { POS[i]=num; return; }
}

void Post::MarkRead(unsigned short ki)
{
  if ( ! MULTIPLE ) return;
  for ( int i=0; i<NB_KI; i++)
    if ( KI[i] == ki ) { KI_Etat[i]='R'; return; }
}

void Post::LIT(S_Load *a)
{
  a->Lit(post);
  a->Lit(&(date), sizeof(date )); 
  a->Lit(right); 
  a->Lit(move_u);
  if ( move_u ) // The post was moved from a room 
      a->Lit(move_r);

  a->Lit(ref_r);
  if ( ref_r )  // The post replies to another post
    {
      a->Lit(ref_n);
      a->Lit(ref_u);
      a->Lit(ref_s);
    }
}

void Post::SAUVE(S_Save *a)
{
  a->Envoie(TYPE_ROOM);
  a->Envoie(post);
  a->Envoie(&(date), sizeof(date ));
  a->Envoie(right);
  a->Envoie(move_u);
  if ( move_u ) // The post was moved from a room 
      a->Envoie(move_r);

  a->Envoie(ref_r);
  if ( ref_r )  // The post replies to another post
    {
      a->Envoie(ref_n);
      a->Envoie(ref_u);
      a->Envoie(ref_s);
    }
}

void Post::RECOIT(unsigned short ki)
{    
  p.Lit(post);
  p.Lit(right);
}

void Post::ENVOIE(unsigned short ki)
{
  Debug(0,"Sending(%c)\n",TYPE_ROOM);
  U.Envoie(TYPE_ROOM);
  U.Envoie(&(date), sizeof(date));
  U.Envoie(post);
  U.Envoie(right);
  U.Envoie(move_u);
  if ( move_u ) U.Envoie(move_r);
  U.Envoie(ref_r);
  if ( ref_r )
    {
      U.Envoie(ref_n);
      U.Envoie(ref_s);
      U.Envoie(ref_u);
    }
}

