
/* 
   Copyright (C) 1992 Free Software Foundation, Inc.
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
   This program have been made by: Gregory VANDENBROUCK , vdb@pipo.com
   Please, send him/them a mail ( possibly with diff and/or correction )
   If you find any BUG, or if you do nay improvement */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>
#include <strings.h>
#include <signal.h> // for SIGPIPE
#include <stdlib.h> // for rand()
#include "Debug.H"
#include "G_Path.H"
#include "S_user.H"
#include "S_Hash_U.H"
#include "consts.H"
#include "G_B_R_Pipe.H"
#include "S_wholist.H"
#include "S_MSG.H"
#include "S_R.H"
#include "S_Error.H"
#include "S_Users.H"
#include "SERVEUR.H"
#include "S_Hash_R.H"
#include "Special_Users.H"
#include "AddLog.H"

 
G_Path G(0);         // Must be first. 0 = no timeout
S_wholist W;         // All shared memory, but the one for messages. Must be fisrt
S_Hash_U ZeHash;     // Hashtable for users
S_Hash_R H_R;        // Hashtable for rooms
S_MSG m;             // messages, depend de rien
S_R R;               // gerer les rooms.
S_Users U;
AddLog L("serveur"); // logs 
G_B_R_Pipe p(G.GetCommFile("pipo")); // Open the pipe,wait for connections

void System_Message(unsigned short nom, unsigned short deki, unsigned short message);

void BougeWholist(unsigned short source, unsigned short destination)
{
  Debug(1,"Wholist: %d -> %d\n",source,destination);
  U.LE[destination]=U.LE[source];
  W.mem->ki[destination]=W.mem->ki[source];
  W.mem->place[destination]=W.mem->place[source];
}

void Hello_From_Client(unsigned short ki)
  // Gerer le message de connection d'un client
{
  int sonpid,id;
  int dble=0;
  char * buffer;
  char BUF[100];

  sprintf(BUF,"U(%s)",W.name(ki));
  L.AddString(BUF);

  if ( U.Set(ki) )
    {
      L.Add("*** double loggin, killed old one ***");
      U.send_signal(SIGTERM);
      U.Del_Encours();
      dble=1;
    }
 
  p.Lit(&sonpid,sizeof(sonpid)); 
  p.Lit(buffer);

  if ( (! buffer) || (strlen(buffer) > (unsigned)LG_NOM_USER) )
    {
      if ( buffer )
	{
	  delete [] buffer;
	}
      else Debug(3,"ERROR: Wrong name given at login \n");
      L.AddString(0);
      return;
    }

  Debug(1,"PID=%d (%d,%s) login in: ",sonpid,ki,buffer);

  L.Add("*** Login in ***");
  L.AddString(0);

  U.Insert ( ki, sonpid );

  if ((id=ZeHash.rechercher(buffer)))
    {
      Debug(1,"exists, usernum = %d\n",id);
    } 
  else
    {
      Debug(1,"NEW USER, inserting name in hash\n");
      ZeHash.insert(buffer,ki);
    }
  delete [] buffer;

  int k;
  for ( k=0; k < MaxWholistTaille; k++ )
  { if ( ! W.mem->Infos[k].OQP ) break; }
  Debug(0,"Wholist: pos=%d total=%d\n",k, W.mem->nbpers);
  USRINFO * poal = W.mem->Infos +k;
  // we clean the wholist ...
  poal->OQP=1;       // place occupied
  poal->u_wholist=0; // no flags wholist
  poal->u_options=0; // no options
  poal->u_rights=0;  // no rights
  poal->nbamis=0; poal->nbennemis=0; poal->nbusr=0;
  // We say who have logged in, and where is the info
  W.mem->place[W.mem->nbpers]=k; // where to get the info
  W.mem->ki[W.mem->nbpers]=ki;   // Who it is
  W.mem->nbpers++;  // we show the entry

  if ( ! U.Set( ki ) ) 
    {
      Debug(3,"ERROR: Hello_from_client, in U.Set(ki)\n");
      return;
    }
  
  U.Envoie((unsigned char)'S');// On dit bijour au mec
  U.flush();

  if (dble) // Prevenir k'on a kille son previous 
    U.SendSX(user_sysop,S_dble_login);

  U.HelloAll(ki);
  W.mem->Stat[N_ser_login] ++;
}

void Bye_From_Client(unsigned short num)
{
  pid_t truc;
  p.Lit(&truc,sizeof(truc));
  Debug(1,"BYE(%d): ",num);
  if (U.Set(num))
  {
    U.Envoie((unsigned char)'K');
    U.flush();
    Debug(1,"OK\n");
    U.Del_Encours();
  } else 
  {
    Debug(1,"PAS LA, kill(%i)\n",truc); 
    //sleep(1); // Humf, pas bo
    //kill(truc,SIGTERM);
  }
}

static char * MSG = 
"--== The bbs is going \\rDOWN\\p for a little time ...==--\n"
"--== Please re-log in in a few minutes. ==--\n      Thanks ";

void Ack(unsigned short nom)
{
  unsigned char type;
  unsigned short pourki;

  p.Lit(pourki);
  p.Lit(type);

  if ( ! U.Set(pourki) ) return;
  U.Envoie((unsigned char)'a');
  U.Envoie(nom);
  U.Envoie(type);
  U.flush();
}

void ReloadInfos(unsigned short nom)
{
  unsigned short aki;
  p.Lit(aki);
  if (! U.Set(nom,aki,(unsigned char)'N') ) return;
  U.Envoie((unsigned char)'N');
  U.flush();
}
 

void System_Message(unsigned short nom, unsigned short deki, unsigned short message)
{
  if ( U.Set(nom,deki,(unsigned char)'*')  ) return; // Le SetUser sur ki est fait ...
  U.SendSX(deki, message);
}

void Bouger(unsigned short pos_init) 
// bouge une personne a une place dans la wholsit
{
  unsigned short pos_final;
  
  p.Lit(pos_final);
  
  if (pos_init >= W.mem->nbpers) pos_init=W.mem->nbpers-1;
  if (pos_final >= W.mem->nbpers) pos_final=W.mem->nbpers-1;

  if (pos_init==pos_final) return;

  unsigned short ki, place;

  class S_user * temp;

  Debug(0,"%d <-> %d, swapping 2 lines of wholist\n",pos_init, pos_final);

  ki = W.mem->ki[pos_init];
  place = W.mem->place[pos_init];
  temp=U.LE[pos_init];
  

  if (pos_init<pos_final) 
      for(int j=pos_init+1;j<=pos_final;j++) BougeWholist(j, j-1);      
  else
      for(int j=pos_init-1;j>=pos_final;j--) BougeWholist(j, j+1);

  W.mem->ki[pos_final] = ki;
  W.mem->place[pos_final] = place;
  U.LE[pos_final] = temp; 
  Debug(0,"Swapping finished\n");
}

void ThrowMedor(unsigned short nom)
{
  Debug(0,"%d envoie medor\n",nom);
  // Orion: met ton code et ton protocole ici !!!
  // Base toi sur ce ki est fait dans la fonction en dessous
  // Si tu as besoin de data en mem partagee, ...... dans le serveur
  // ou koi, bah file moi les specs je m'en occupe
  // si tu envoies kekechose a un client, commence comme ca:
  // U.Set(ki);     // envoi d'1 msg a ki
  // U.Envoie('M'); // Medor msg
  // U.Envoie(.....); // ce ke tu veux, gere ton protocole
  // ...
  // U.flush();
}

void ThrowTag(unsigned short nom)
  // a client ( nom ) has asked to throw the tag ...
{
  USRINFO * poal = W.User(nom);
  if ( ! poal ) return;
  if ( ! ( poal->u_options & U_PTag ) ) // the user is not allowed to play
    {
      U.Set(nom);
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'e'); // Not a player
      U.flush();
      return;
    }
  // The serveur is going to see what to do
  LISTE a(MaxWholistTaille); // Who can receive Coco ...

  for (int i=0; i< W.mem->nbpers;i++)
    {
      if ( (W.mem->Infos + W.mem->place[i])->u_options & U_PTag )
	a.Ajoute(W.mem->ki[i]);
    }
  // Who has the tag ?
  unsigned short k = W.HaveTAG();
  // Not enough players ...
  if ( a.size() < W.mem->DAT[N_CocoMin] )
    {
      if ( k == nom ) W.SwapTag(nom); // remove the Tag of user nom
      U.Set(nom);
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'N'); // Not Available
      U.flush();
      return;
    }
  time_t t = time(0); // get current time
  if ( k == nom ) // ok, he has got the tag
    {   
      k = a.DATA[rand() % a.size()];
      W.SwapTag(nom); // remove Tag from nom
      U.Set(nom);// We say to user nom that the tag have been sent
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'S'); // Sent
      U.Envoie(k);                  // to user k
      U.Envoie(&t,sizeof(t));       // at time t
      U.flush();
      W.SwapTag(k);  // Set tag on user k
      U.Set(k);// We send the Coco to user k
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'R'); // Receive
      U.Envoie(nom);                // from nom
      U.Envoie(&t,sizeof(t));       // at time t
      U.flush();     
      return;
    }
  if ( ! k )  // No ome have the Tag yet, we create it
    {
      W.SwapTag(nom);  // Put tag on nom
      U.Set(nom);
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'F'); // Flap flag, comming
      U.flush();
      return;
    }
  // here, user k has the tag, user nom tried to send it, 
  // error if user not enough IDLE ( loose points ),
  // else take it from k 
  USRINFO * poil = W.User(k); // Take info of user k
  if ( ! poil ) return; // k not loged, should not happened !!
  if ( t - poil->last >= 10 * 60 ) // > 10 min IDLE
    {
      W.SwapTag(k);           // change state of TAG on user nom
      U.Set(k);
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'L'); // lost
      U.Envoie(nom);                // from nom
      U.flush();
      W.SwapTag(nom);           // change state of TAG on user nom
      U.Set(nom);
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'F'); // Flap flag, comming
      U.flush();
    }
  else
    {
      U.Set(nom);
      U.Envoie((unsigned char)'T'); // Tag ( = Coco )
      U.Envoie((unsigned char)'E'); // Error, owned by an other user
      U.Envoie(k);        
      U.flush();   
    }
}

void GereListe(unsigned short nom)
{
  unsigned short num;
  unsigned char action;
  p.Lit(num);
  p.Lit(action);
  Debug(0,"S_Liste::Gere(l=%d,u=%d,a=%c)\n",num,nom,action);
  if ( num >= MAX_LISTE )
    {
      Debug(2,"GereListe:: Too big number !!\n");
      return;
    }
  

  LISTEINFO * A = &(W.mem->Listes[num]);
  LISTE poal(MAX_ABONES_LISTE,A->Abone,&(A->NB_Abones));

  switch ( action )
    {
    case 'a': // Add User
      poal.Ajoute(nom);
      break;
    case 'r': // Remove
      poal.Enleve(nom);
      break;
    default: Debug(2,"wrong case in list-action !!\n");
    }
}

void Read_Infos(void)
{
  Debug(2,"Reading server Infos\n");
  Dat * D;
  D = new Dat(cle,tailles,MAX_SER_CH,  0);
  FileInfo FF(G.GetEtcHome("serveur"),k_Read,D);
  FF.Proceed();
  int i;
  for ( i=0; i< NB_ser_int; i++)
    W.mem->DAT[i]=D->Num(i);
  for ( i=0; i< NB_ser_chaines; i++ )
    strcpy(W.mem->St[i],D->St(i).data());
  delete  D;
}

void DeleteUsers(unsigned short nom)
{
  String reason;
  LISTE accounts(MAX_USERS);

  p.Lit(reason);
  p.Lit(accounts);

  char BUF[100];

  sprintf(BUF,"S(%s)",W.name(nom));
  L.AddString(BUF);
  
  sprintf(L.buf(),"DELETED ACCOUNTS REASON: '%s'",reason.data());
  L.Add();
  int i;

  char buf[200];

  for (i=0; i<accounts.size(); i++)
    {

      unsigned short ki = accounts.DATA[i];

      sprintf(L.buf(),"Deleted %s(%d)",W.name(ki),ki);
      L.Add();

      char * h = G.GetUserFile(W.name(accounts.DATA[i]),"");
      Debug(3,"Deleting user %s(%d)\n",W.name(ki),ki);
      Debug(3,"Deleting directory '%s'\n",h);
      sprintf(buf,"rm -rf '%s'",h);
      system(buf);
      delete [] h;
      
    }

  sprintf(buf,"%s%s","users/","liste");

  char * tp = G.GetEtcHome(buf);

  Debug(3,"Updating file '%s'\n",tp);

  sprintf(buf,"%s%s","users/","liste.new");

  char * tp2 = G.GetEtcHome(buf);

  FILE * f,* f2;

  if (!(f=fopen(tp,"r"))) 
    Debug(3,"NO USER FILE !!!!!!\n"); 
  else
    {
  
      f2=fopen(tp2,"w");
      
      int k = 0;
      
      while ( fgets(buf,sizeof(buf),f) )
	{
	  k++;
	  
	  buf[strlen(buf)-1]=0;
	  
	  if ( ! buf[0]  ) fprintf(f2,"\n");
	  else
	    {
	      int found = 0;
	      
	      for ( i=0; i<accounts.size();i++) 
		if (  ! strcmp(buf,W.name(accounts.DATA[i]) ) )
		  {
		    Debug(3,"%s found !\n",W.name(accounts.DATA[i]) );
		    fprintf(f2,"\n");
		    found = 1;
		    break;
		  }
	      if ( ! found ) fprintf(f2,"%s\n",buf);
	    }
	} 
      fclose(f);
      fclose(f2);
      
      sprintf(buf,"cp %s %s",tp2,tp);
      system(buf);      
    }
  
  delete [] tp;  
  delete [] tp2;
  
  for (i=0; i<accounts.size(); i++)
    {
      ZeHash.remove(accounts.DATA[i]);
    }

  L.AddString(0); 
}


int main(void)
{
  unsigned char ch;
  unsigned short nom;
  close(0);

  signal(SIGPIPE,SIG_IGN); // On ignore les SIGPIPES

  // On code en hard ke les "users" All, Friends, et Other sont "connectes"
  //  for (n=1;n<4;n++) W.mem->u_flag[n]=W_Here; 
  
  Read_Infos();

  L.Add("*** Server started ! ***");

  Debug(2,"Initialisation completed, now dealing with connections\n");

  while ( 1 )
    {
      p.ResetSelect();
      p.AddSelect(p.f_r);
      int nb_pret = p.Select(0);
      if ( nb_pret != -1 )
      try
	{
	  if ( p.InitRead() )
	    {
	      p.LitMsg(ch,nom);
	  
	      switch(ch)
		{
		case 'R': R.Dispatch(nom); break;
		case 'a': Ack(nom); break;
		case 'b': Bye_From_Client(nom); break;
		case 'h': Hello_From_Client(nom); break;	    
		case 'm': Bouger(nom); break;
		case 'n': m.Load(); break;
		case 'N': ReloadInfos(nom); break;	   
		case 'r': U.KickAll(nom,MSG); break;
		case 'T': ThrowTag(nom); break;
		case 'M': ThrowMedor(nom); break;
		case 'U': DeleteUsers(nom); break;
		case 'l': GereListe(nom); break;
		case 'c': Read_Infos(); break;
		default: Debug(3,"Did NOT understand %c in main protocol\n",ch);
		}
	    }
	  else
	    printf("RECU PACQUET NON COMPLET => ATTENTE\n");
	}
      catch ( PlusPersonne ) 
	{
	  Debug(3,"No one left\n");
	  break;
	}
      catch ( RecvPipeProbs )
	{
	  Debug(3,"ERROR: while reading\n");
	}
      catch ( S_Error S )
	{
	  if ( S.ki() ) System_Message(S.ki(),user_sysop, S.koa());
	}
      catch ( SendPipeProbs )
	{
	  Debug(3,"Error with user, catching\n");
	  U.Del_Encours();
	}

      fflush(stdout);
    }

  Debug(3,"Normally closing the BBS server\n");
  L.Add("server normally closed :o)");
  return 0;
}

void terminate(void)
{
  Debug(3,"Non catched event !\n");
  exit(1);
}







