#include "Protocol.H"

void Protocol::afficher_msgbody (struct maillon_message_field *mai)
        {
	if (mai == NULL)
	        return;
	if ((mai->field_name == NULL) || (mai->field_value == NULL))
                return;
	printf ("\t%s = \"%s\"\n", mai->field_name, mai->field_value);
	afficher_msgbody (mai->next);
	}

void Protocol::afficher_message (void)
        {
	if (mesg == NULL)
	        return;
	if ((mesg->msgtype == NULL) || (mesg->msgrange == NULL))
                return;
	printf ("Message recu apres analyse :\n%c (%c)\n", *(mesg->msgtype), *(mesg->msgrange));
	if (mesg->msgbody == NULL)
	        return;
	printf ("\t{\n");
	afficher_msgbody (mesg->msgbody);
	printf ("\t}\n\n");
	}

void Protocol::destroy_msgtype (char **msgtype)
        {
	if (*msgtype != NULL)
	        {
	      	free (*msgtype);
		*msgtype = NULL;
		}
	}

void Protocol::destroy_msgrange (char **msgrange)
        {
	if (*msgrange != NULL)
	        {
	      	free (*msgrange);
		*msgrange = NULL;
		}
	}

void Protocol::destroy_string (char **maillon)
        {
	if (*maillon != NULL)
	        {
		free (*maillon);
		*maillon = NULL;
		}
	}

void Protocol::destroy_maillon (struct maillon_message_field **maillon)
        {
	if (*maillon != NULL)
	        {
		destroy_string (&((*maillon)->field_name));
		destroy_string (&((*maillon)->field_value));
		free ((*maillon)->next);
		*maillon = NULL;
		}
	}

void Protocol::destroy_msgbody (struct maillon_message_field **msgbody)
        {
	if (*msgbody != NULL)
	        {
		destroy_msgbody (&((*msgbody)->next));
		destroy_maillon (msgbody);
		*msgbody = NULL;
		}
	}
	
void Protocol::destroy_message (void)
        {
	if (mesg != NULL)
	        {
		destroy_msgtype (&(mesg->msgtype));
		destroy_msgrange (&(mesg->msgrange));
		destroy_msgbody (&(mesg->msgbody));
		free (mesg);
		mesg = NULL;
		}
	}

int Protocol::next_token (char *buffer)
        {
	int i = 0;

	while ((buffer [i] == ' ') || (buffer [i] == '\n') || (buffer [i] == '\t'))
		i++;

	return i;
	}

int Protocol::chars (char c)
        {
	if (((c >= 'a') && (c <= 'z')) || ((c >= 'A') && (c <= 'Z')))
	        return 1;
	return 0;
	}

void Protocol::new_token (char *buffer, char *ptoken, int *token_length)
        {
	int i = 1;
	int j;
	int cont  = 1;
	int last_was_slash = 0;
	int k = 0;

	if (buffer [0] != '"')
	        {
		if (chars (buffer [0]))
		        {
			while (chars (buffer [i]))
			        i++;
			}

		for (j = 0; j < i; j++)
		        ptoken [j] = buffer [j];
		ptoken [i] = '\0';
		*token_length = i;
		}
	else
	        {
		do
		        {
			if ((buffer [i] == '\\') && (last_was_slash == 0))
				last_was_slash = 1;
			else
			        {
			        if ((buffer [i] == '\0') || ((buffer [i] == '"') && (last_was_slash == 0)))
				        cont = 0;
				last_was_slash = 0;
				}
			i++;
			}
		while (cont);

		for (j = 1; j < (i - 1); j++)
		        {
			if ((buffer [i] == '\\') && (last_was_slash == 0))
				last_was_slash = 1;
			else
			        {
				last_was_slash = 0;
				ptoken [k] = buffer [j];
				k++;
				}
			}
		ptoken [k] = '\0';
		*token_length = i;		
		}
	}

char Protocol::token_analysis (char *ptoken)
        {
	if (strcmp (ptoken, "S") == 0)
	        return 'S';
	if (strcmp (ptoken, "s") == 0)
	        return 'S';
	if (strcmp (ptoken, "A") == 0)
	        return 'A';
	if (strcmp (ptoken, "a") == 0)
	        return 'A';
	if (strcmp (ptoken, "G") == 0)
	        return 'G';
	if (strcmp (ptoken, "g") == 0)
	        return 'G';
	if (strcmp (ptoken, "{") == 0)
	        return '{';
	if (strcmp (ptoken, "}") == 0)
	        return '}';
	if (strcmp (ptoken, "(") == 0)
	        return '(';
	if (strcmp (ptoken, ")") == 0)
	        return ')';
	if (strcmp (ptoken, "L") == 0)
	        return 'L';
	if (strcmp (ptoken, "l") == 0)
	        return 'L';
	if (strcmp (ptoken, "answer") == 0)
	        return 'a';
	if (strcmp (ptoken, "login") == 0)
	        return 'l';
	if (strcmp (ptoken, "password") == 0)
	        return 'p';
	if (strcmp (ptoken, "=") == 0)
	        return '=';
	return 'E';	// Unrecognized token
	}

int Protocol::analys_msgtype (char *buffer, int *to_next_token_to_read, char **msgtype)
        {
	int avancer;
	int erreur;
	char ptoken [80];
	int token_length;

	erreur = 0;
	avancer = next_token (buffer);

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case 'S':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'S';
			}
		break;
		case 'A':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'A';
			}
		break;
		case 'G':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'G';
			}
		break;
		case 'C':
		        {
			*msgtype = (char *) malloc (sizeof (char));
			**msgtype = 'C';
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));
	*to_next_token_to_read = avancer;

	return erreur;
	}

int Protocol::analys_msgrange (char *buffer, int *to_next_token_to_read, char **msgrange)
        {
	int avancer;
	int erreur;
	char ptoken [80];
	int token_length;

	erreur = 0;
	avancer = next_token (buffer);

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '(':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case 'L':
		        {
			*msgrange = (char *) malloc (sizeof (char));
			**msgrange = 'L';
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case ')':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));


	*to_next_token_to_read = avancer;

	return erreur;
	}

int Protocol::analys_msgbody (char *buffer, int *to_next_token_to_read, struct maillon_message_field **msgbody)
        {
	struct maillon_message_field *msgbodycopy;
	int avancer;
	int erreur;
	char ptoken [80];
	int token_length;

	erreur = 0;
	avancer = next_token (buffer);

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '{':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}
	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case 'a':
		        {
			*msgbody = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			(*msgbody)->field_name = (char *) malloc (7 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "answer\0");
			}
		break;
		case 'l':
		        {
			*msgbody = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			(*msgbody)->field_name = (char *) malloc (6 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "login\0");
			}
		break;
		case 'p':
		        {
			*msgbody = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			(*msgbody)->field_name = (char *) malloc (9 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "password\0");
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	msgbodycopy = *msgbody;

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '=':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        erreur = -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        erreur = -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	(*msgbody)->field_value = (char *) malloc ((token_length + 1) * sizeof (char));
	strcpy ((*msgbody)->field_value, ptoken);

	avancer += next_token (&(buffer [avancer]));

	while (1)
	{

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;
	switch (token_analysis (ptoken))
	        {
		case '}':
		        {
			avancer += next_token (&(buffer [avancer]));

			*to_next_token_to_read = avancer;
			*msgbody = msgbodycopy;

			return erreur;			
			}
		break;
		case 'a':
		        {
			(*msgbody)->next = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			*msgbody = (*msgbody)->next;
			(*msgbody)->field_name = (char *) malloc (7 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "answer\0");
			}
		break;
		case 'l':
		        {
			(*msgbody)->next = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			*msgbody = (*msgbody)->next;
			(*msgbody)->field_name = (char *) malloc (6 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "login\0");
			}
		break;
		case 'p':
		        {
			(*msgbody)->next = (struct maillon_message_field *) malloc (sizeof (struct maillon_message_field));
			*msgbody = (*msgbody)->next;
			(*msgbody)->field_name = (char *) malloc (9 * sizeof (char));
			(*msgbody)->field_value = NULL;
			(*msgbody)->next = NULL;
		       	strcpy ((*msgbody)->field_name, "password\0");
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        return -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        return -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	switch (token_analysis (ptoken))
	        {
		case '=':
		        {
			}
		break;
		case 'E':
		        {
			// Error! Token not recognized
		        return -1;
			}
		break;
		default:
		        {
			// Error! Syntax not recognized
		        return -2;
			}
		}

	avancer += next_token (&(buffer [avancer]));

	new_token (&(buffer [avancer]), ptoken, &token_length);
	avancer += token_length;

	(*msgbody)->field_value = (char *) malloc ((token_length + 1) * sizeof (char));
	strcpy ((*msgbody)->field_value, ptoken);

	avancer += next_token (&(buffer [avancer]));
	}

	// On ne devrait jamais arriver la

	*to_next_token_to_read = avancer;
	*msgbody = msgbodycopy;

	return erreur;
	}

int Protocol::analys_msg (char *buffer, struct message **message)
        {
	int token_length;
	char *msgtype;
	char *msgrange;
	struct maillon_message_field *msgbody;

	msgtype = NULL;
	msgrange = NULL;
	msgbody = NULL;

	if (analys_msgtype (buffer, &token_length, &msgtype) < 0)
	        {
		printf ("Erreur dans la reconnaissance du type de message\n");
		return -1;
		}

	if (analys_msgrange (&(buffer [token_length]), &token_length, &msgrange) < 0)
	        {
		printf ("Erreur dans la reconnaissance du range du message\n");
		destroy_msgtype (&msgtype);
		return -1;
		}

	if (analys_msgbody (&(buffer [token_length]), &token_length, &msgbody) < 0)
	        {
		printf ("Erreur dans la reconnaissance du body du message\n");
		destroy_msgtype (&msgtype);
		destroy_msgrange (&msgtype);
		return -1;
		}

	printf ("\n");
	*message = (struct message *) malloc (sizeof (struct message));
	(*message)->msgtype = msgtype;
	(*message)->msgrange = msgrange;
	(*message)->msgbody = msgbody;

	afficher_message ();
	return 0;
	}

int Protocol::analysis (char *buffer)
        {
	int result;
	result = analys_msg (buffer, &mesg);
	return result;
	}

int Protocol::analysis_login (char *buffer, char **login_name, char **login_pass)
        {
	int result = 0;

	if (analys_msg (buffer, &mesg) < 0)
	        {
		result = -3;
		}
	else
	        {
		if ((mesg != NULL)
		    && (mesg->msgtype != NULL)
		    && (mesg->msgrange != NULL)
		    && (mesg->msgbody != NULL)
		    && (*(mesg->msgtype) == 'S')
		    && (*(mesg->msgrange) == 'L')
		    && (mesg->msgbody != NULL)
		    && (mesg->msgbody->field_name != NULL)
		    && (mesg->msgbody->field_value != NULL)
		    && (mesg->msgbody->next != NULL)
		    && (strcmp (mesg->msgbody->field_name, "login") == 0)
		    && (mesg->msgbody->next->field_name != NULL)
		    && (mesg->msgbody->next->field_value != NULL)
		    && (mesg->msgbody->next->next == NULL)
		    && (strcmp (mesg->msgbody->next->field_name, "password") == 0)
		    )
		        {
			strcpy (*login_name, mesg->msgbody->field_value);
			strcpy (*login_pass, mesg->msgbody->next->field_value);
			result = 0;
			}
		else
		        {
			result = -2;
			}
		}

	return result;
	}

Protocol::Protocol (void)
        {
	mesg = NULL;
	}

Protocol::~Protocol (void)
        {
	destroy_message ();
	}
