#ifndef __SOCKET__
#define __SOCKET__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "Protocol.H"
#include "C_User_C.H"
#define BUFF_LENG 80			// Taille du buffer


class Socket
	{
	public:
	Socket (int);
	~Socket ();
	void Set (class C_User_C *);					// Set Pi
	void Gere (void);						// Gere a msg received on socket
	void SendX (const char *, unsigned short, unsigned char);	// Send an X to client
	int GetLogin (char **, char **);						// Get client login
	void SendAckLog (const char *);					// Send login Acknowledgment

	private:
	char buffer [BUFF_LENG];        // Buffer de messages serveur-client
	int count;                      // Longueur du message dans le buffer
	int fd; 			// socket descriptor (to client)
	C_User_C *Pi;			// Pipe descriptor (to server)
	Protocol msg;			// Protocole qui analyse le buffer et le gere
	};



#endif

